# 空间折叠(Fspace)数据埋点 SDK

空间折叠前端- 用户行为数据采集SDK

## install
---
```
npm install fspacefe-tracker

yarn add fspacefe-tracker

// cdn
<script src="https://cdn.jsdelivr.net/npm/fspacefe-tracker@0.0.9/lib/index.min.js"></script>
```

## init
---
```js
import FSTracker from "fspacefe-tracker";

const fst = new FSTracker({
  url: "", // 服务地址
  vue: Vue,
  debug: true,
  platform: "1",
  session_id: "",
  device_name: "huawei",
  enableHeatMap: true, // 开启热力图
});
```

## Options
---
| 参数          | 必填 | 默认值 | 类型   |                                             |
| ------------- | ---- | ------ | ------ | ------------------------------------------- |
| platform      | 是   | ''     | string | 设备类型 ANDROID ,2 IOS ,3 PC WEB, 4 WECHAT |
| device_name   | 否   | ''     | string | 设备名称                                    |
| debug         | 否   | false  | bool   | 开启调试模式                                |
| url           | 是   | ''     | string | 请求地址                                    |
| cvs           | 是   | ''     | string | 客户端版本号                                |
| enableHeatMap | 否   | false  | bool   | 开启热力图                                  |
| enableAutoPV  | 否   | false  | bool   | 开启自动上传                                |
| company_oid   | 否   | ''     | string | 客户 id                                     |

## Methods
---
| 方法名      | 说明         | 参数     |
| ----------- | ------------ | -------- |
| setConfig   | 设置全局参数 | Options  |
| sendTracker | 手动上报     | {自定义} |

## Directives
---
指令会自动上报

### Vue2.0 
---
| 方法名        | 说明     | 参数 |
| ------------- | -------- | ---- |
| v-track:click | 点击事件 | ...  |
| v-track:keyup | 键盘事件 | ...  |

```html
// 点击
<div v-track:click="{'event_type': 12, ...}">加入购物车</div>

// 键盘
<div v-track:keyup="{'event_type': 10, ...}">搜索</div>
```

## demo
---
```js
import FSTracker from "fspacefe-tracker";

const fst = new FSTracker({
  url: "", // 服务地址
  vue: Vue,
  debug: true,
  platform: "1",
  session_id: "",
  device_name: "huawei",
  enableHeatMap: true, // 开启热力图
});

// 更新传参
fst.setConfig(options);

// 自定义上传
fst.sendTracker(params);
```


## build
---
```
npm build

npm publish
```


持续完善中...