(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.FSTracker = factory());
})(this, (function () { 'use strict';

  const defaultOptions = {
    vue: null,
    debug: false,
    platform: "",
    // 渠道 1 ANDROID ,2 IOS ,3 PC WEB, 4 WECHAT

    session_id: "",
    // 用户请求

    device_name: "",
    // 设备类型

    session_id: "",
    company_oid: "",
    url: "",
    // 埋点请求后端接口

    enableHeatMap: false,
    enableHashTracker: false
  };
  const defaultTrackClickOptions = {
    event_type: 7,
    //事件类型,  1:登录  2:登出  3:注册  4:启动应用 5:打开页面 6:跳出页面 7:浏览 8:曝光 9:点击？ 10:搜索 11:滑动窗口 12:加购 13:立购 14:确认订单 15:提交订单 16:取消订单 17:支付 18:退款 19:收藏  20:取消收藏，根据需要扩展

    duration_time: 0,
    // 持续时长 如启动应用所耗时间，打开页面所耗时间等

    page_id: "",
    // 当前页面 唯一页面编号，对应埋点配置字典

    host_ip: "",
    pre_page_id: "",
    // 上级页面编号 一般指页面编号，用于链路跟踪，对应埋点配置字典（td_buried_point_dict.dcid,  type=1)

    company_oid: "",
    // 公司ID ,登录后存在

    page_type: 1,
    // 页面类型 1:普通(默认) 2:运营 3:广告 4:活动

    position: "",
    // 位置范围编号  广告、运营或者活动的具体位置范围编号，兼容单个或多个，一般是连续编号，由二段组成，格式：起始位,终止位。如：1,10 表示从1号到10号位，1,1表示单个位。可应用于单个事件或批量事件

    object_ids: "",
    // 对象ID集合  页面内容对应的具体业务ID集合，兼容单个或多个，如商品、广告、活动、订单等ID，格式：以逗号分隔的id字符串，如1,2,3,4,5。可应用于单个事件或批量事件

    search_key: ""
    // 搜索关键字  搜索事件中需要上报
  };

  const xmlHttpRequest = function (url, data) {
    const xhr = new XMLHttpRequest();
    xhr.open("POST", url, false);
    xhr.setRequestHeader("Content-Type", "application/json");
    xhr.setRequestHeader("Access-Control-Allow-Origin", "*");
    xhr.send(JSON.stringify(data));
  };
  const trackingToPageParams = id => {
    id = id.toString();
    if (!id && id.length < 2) return {};
    const page_type = id.slice(0, 1);
    const page_id = id.slice(1);
    return {
      page_type,
      page_id
    };
  };
  const getheatMap = (x, y) => {
    return `${x}.${y}`;
  };
  function extend(target, source) {
    for (var obj in source) {
      if (target[obj]) {
        target[obj] = source[obj];
      }
    }
    return target;
  }
  const dvRequest = function (options) {
    const params = JSON.parse(localStorage.getItem("fspace-tracker")) || null;
    if (!params) return;
    const {
      url,
      platform,
      enableHeatMap,
      device_name,
      session_id,
      company_oid
    } = params;
    let position = enableHeatMap && options.x && options.y ? getheatMap(options.x, options.y) : "";
    options = extend(defaultTrackClickOptions, options);
    const defaultData = {
      channel: platform,
      device_type: device_name,
      session_id: session_id,
      company_oid: company_oid,
      ...options,
      position,
      ...trackingToPageParams(options.tracking)
    };
    xmlHttpRequest(url, defaultData);
  };
  const cConsole = function (text, type = "log") {
    this._options.debug && console[type](text);
  };
  function initGlobalFun(FSTracker) {
    FSTracker.prototype.setConfig = function (options) {
      options = Object.assign({}, this._options, options);
      localStorage.setItem("fspace-tracker", JSON.stringify(options));
    };
    FSTracker.prototype.sendTracker = function (data = {}) {
      const defaultData = {
        channel: this._options.platform,
        device_type: this._options.device_name,
        session_id: this._options.session_id,
        company_oid: this._options.company_oid,
        ...data
      };
      cConsole.call(this, defaultData);
      xmlHttpRequest(this._options.url, defaultData);
    };
  }

  class Click {
    add(entry) {
      entry.el.addEventListener("click", function (e) {
        dvRequest({
          ...entry.binding.value,
          x: e.clientX,
          y: e.clientY
        });
      });
    }
    remove(entry) {
      entry.el.removeEventListener("click", () => {});
    }
  }

  class Keyup {
    add(entry) {
      entry.el.addEventListener("keyup", function (e) {
        if (e.keyCode === 13) {
          dvRequest(entry.binding.value);
        }
      });
    }
    remove(entry) {
      entry.el.removeEventListener("keyup", () => {});
    }
  }

  class Exposure {
    add(entry) {
      entry.el.attributes["track-pid"].value;
      entry.el.attributes["track-params"].value;
      console.log(entry.value);
    }
  }

  // 实例化曝光和点击
  const exp = new Exposure();
  const cli = new Click();
  const keyup = new Keyup();
  const track = {
    inserted: function (el, binding) {
      const {
        arg
      } = binding;
      arg.split("|").forEach(item => {
        // 点击
        switch (item) {
          case "click":
            cli.add({
              el,
              binding
            });
            break;
          case "keyup":
            keyup.add({
              el,
              binding
            });
            break;
          case "exposure":
            exp.add({
              el
            });
            break;
        }
      });
    },
    unbind(el, binding) {
      const {
        arg
      } = binding;
      arg.split("|").forEach(item => {
        // 点击
        switch (item) {
          case "click":
            cli.remove({
              el,
              binding
            });
            break;
          case "keyup":
            keyup.remove({
              el,
              binding
            });
            break;
          case "exposure":
            exp.remove({
              el,
              binding
            });
            break;
        }
      });
    }
  };
  function setTrackDirectives(app) {
    app.directive("track", track);
  }

  const setVueGlobDirectives = (app, FSTracker) => {
    setTrackDirectives(app);
  };

  const initHashEvent = (fs, options) => {
    window.addEventListener('hashchange', e => {
      console.log(e);
    });
  };

  function _setConfig(fs, options) {
    options = Object.assign({}, defaultOptions, options);
    fs._options = options;
    localStorage.setItem('fspace-tracker', JSON.stringify(options));
  }
  function _initDirectives(app) {
    setVueGlobDirectives(app);
  }
  function _initEvent(fs, options) {
    // 开始hash router 监听
    if (options.enableHashTracker) {
      initHashEvent();
    }
  }
  function initMixin(FSTracker) {
    FSTracker.prototype._init = function (options) {
      const fs = this;
      if (options) {
        _setConfig(fs, options);
        _initEvent(fs, options);
      }
      if (options.vue) {
        _initDirectives(options.vue);
      }
    };
  }

  /**
   * 初始化埋点sdk
   * @param {*} options
   */
  function FSTracker(options) {
    this._init(options);
  }
  initMixin(FSTracker);
  initGlobalFun(FSTracker);

  return FSTracker;

}));
